package fr.natan.cleanarchitectureprojectservice.infranstructure.ports.input.feignclients.services;

import fr.natan.cleanarchitectureprojectservice.infranstructure.ports.input.feignclients.entities.EmployeeModel;
import fr.natan.cleanarchitectureprojectservice.infranstructure.ports.input.feignclientsfallback.EmployeeSeviceProxyFallback;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

@FeignClient(name = "CLEAN-ARCHI-BUSINESS-SERVICE-EMPLOYEE", fallback = EmployeeSeviceProxyFallback.class)
public interface EmployeeServiceProxy {
    @GetMapping(value = "/employees/{employeeID}")
    EmployeeModel getEmployeeByID(@PathVariable(name = "employeeID") String employeeID);
}
